SystemOrganization addCategory: #'Stack-Exercise-Barroumeres-Laje'!

Object subclass: #MyOOStack
	instanceVariableNames: 'myXXX'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stack-Exercise-Barroumeres-Laje'!

MyOOStack subclass: #MyEmptyOOStack
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stack-Exercise-Barroumeres-Laje'!

MyOOStack subclass: #MyNotEmptyOOStack
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stack-Exercise-Barroumeres-Laje'!

Object subclass: #OOStack
	instanceVariableNames: 'stackElements myOOStack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stack-Exercise-Barroumeres-Laje'!

!OOStack class methodsFor: 'error descriptions' stamp: 'HernanWilkinson 5/7/2012 11:51'!
stackEmptyErrorDescription
	
	^ 'Stack is empty'! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 5/14/2012 19:34'!
initialize 

	super initialize.
	stackElements := OrderedCollection new! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 5/14/2012 19:45'!
isEmpty
	"comment stating purpose of message"

	| temporary variable names |
	^ stackElements size = 0! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 5/14/2012 20:10'!
pepe
	"comment stating purpose of message"

	| temporary variable names |
	self error: self class stackEmptyErrorDescription  ! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 5/14/2012 20:13'!
pop 
	"comment stating purpose of message"
	self isEmpty ifTrue: [self pepe].

	^ stackElements removeLast.! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 5/14/2012 19:38'!
push: anElement

	| temporary variable names |
	stackElements add: anElement. ! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 5/14/2012 19:58'!
size 
	"comment stating purpose of message"

	^ stackElements size! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 5/14/2012 20:17'!
top 
	"comment stating purpose of message"
	self isEmpty ifTrue: [self pepe].
	^ stackElements at: stackElements size! !

TestCase subclass: #OOStackTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stack-Exercise-Barroumeres-Laje'!

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:30'!
test01StackShouldBeEmptyWhenCreated

	| stack |
	
	stack := OOStack new.
	
	self assert: stack isEmpty! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:30'!
test02PushAddElementsToTheStack

	| stack |
	
	stack := OOStack new.
	stack push: 'Something'.
	
	self deny: stack isEmpty! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:31'!
test03PopRemovesElementsFromTheStack

	| stack |
	
	stack := OOStack new.
	stack push: 'Something'.
	stack pop.
	
	self assert: stack isEmpty! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/8/2012 08:20'!
test04PopReturnsLastPushedObject

	| stack pushedObject |
	
	stack := OOStack new.
	pushedObject := 'Something'.
	stack push: pushedObject.
	
	self assert: stack pop = pushedObject! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:33'!
test05StackBehavesLIFO

	| stack firstPushedObject secondPushedObject |
	
	stack := OOStack new.
	firstPushedObject := 'First'.
	secondPushedObject := 'Second'.
	
	stack push: firstPushedObject.
	stack push: secondPushedObject.
	
	self assert: stack pop = secondPushedObject.
	self assert: stack pop = firstPushedObject.
	self assert: stack isEmpty 
	! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:35'!
test06TopReturnsLastPushedObject

	| stack pushedObject |
	
	stack := OOStack new.
	pushedObject := 'Something'.
	
	stack push: pushedObject.
	
	self assert: stack top = pushedObject.
	! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:36'!
test07TopDoesNotRemoveObjectFromStack

	| stack pushedObject |
	
	stack := OOStack new.
	pushedObject := 'Something'.
	
	stack push: pushedObject.
	
	self assert: stack size = 1.
	stack top.
	self assert: stack size = 1.
	! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:38'!
test08CanNotPopWhenThereAreNoObjectsInTheStack

	| stack  |
	
	stack := OOStack new.
	self
		should: [ stack pop ]
		raise: Error
		withExceptionDo: [ :anError |
			self assert: anError messageText = OOStack stackEmptyErrorDescription ]
		
! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:39'!
test09CanNotTopWhenThereAreNoObjectsInTheStack

	| stack  |
	
	stack := OOStack new.
	self
		should: [ stack top ]
		raise: Error
		withExceptionDo: [ :anError |
			self assert: anError messageText = OOStack stackEmptyErrorDescription ]
		
! !
